︠d78931ed-ef0f-468e-bc22-d1ff42097ab0︠
import pandas as pd
import seaborn as sns
import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets
from sklearn.cluster import KMeans
from sklearn import preprocessing 
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression
from sklearn.metrics import r2_score
from mpl_toolkits.mplot3d import Axes3D

df_tips = sns.load_dataset("tips")

X = pd.DataFrame(df_tips, columns = ['tip'])
print(df_tips.head())
︡dd9af7a5-ea55-4917-9d23-7f10b90cd491︡{"stdout":"   total_bill   tip     sex smoker  day    time  size\n0       16.99  1.01  Female     No  Sun  Dinner     2\n1       10.34  1.66    Male     No  Sun  Dinner     3\n2       21.01  3.50    Male     No  Sun  Dinner     3\n3       23.68  3.31    Male     No  Sun  Dinner     2\n4       24.59  3.61  Female     No  Sun  Dinner     4\n"}︡{"done":true}︡
︠1aba1eb2-f15d-4a24-9e47-e02ad9f26321︠


︡93458d3f-4f3f-4eeb-ac75-1ceb591d314d︡{"stdout":"<class 'pandas.core.series.Series'>\n"}︡{"done":true}︡
︠06d8a6c4-5fb3-4f80-bdb4-269fa3c37451︠
tipperc = df_tips['tip'] / df_tips['total_bill']
print(tipperc)
︡89d9be45-756f-49ba-b6c6-c94467b6d44d︡{"stdout":"0      0.059447\n1      0.160542\n2      0.166587\n3      0.139780\n4      0.146808\n5      0.186240\n6      0.228050\n7      0.116071\n8      0.130319\n9      0.218539\n10     0.166504\n11     0.141804\n12     0.101816\n13     0.162778\n14     0.203641\n15     0.181650\n16     0.161665\n17     0.227747\n18     0.206246\n19     0.162228\n20     0.227679\n21     0.135535\n22     0.141408\n23     0.192288\n24     0.160444\n25     0.131387\n26     0.149589\n27     0.157604\n28     0.198157\n29     0.152672\n         ...   \n214    0.230742\n215    0.085271\n216    0.106572\n217    0.129422\n218    0.186047\n219    0.102522\n220    0.180921\n221    0.259314\n222    0.223776\n223    0.187735\n224    0.117735\n225    0.153657\n226    0.198216\n227    0.146699\n228    0.204819\n229    0.130199\n230    0.083299\n231    0.191205\n232    0.291990\n233    0.136490\n234    0.193175\n235    0.124131\n236    0.079365\n237    0.035638\n238    0.130338\n239    0.203927\n240    0.073584\n241    0.088222\n242    0.098204\n243    0.159744\nLength: 244, dtype: float64\n"}︡{"done":true}︡
︠48753b62-0ec9-4752-89ed-9fd61fa09fb8so︠
#tippera = np.array(tipperc)
newX = pd.DataFrame([tipperc], columns = 'tip_perc')
print(newX)
︡621a3321-be81-4957-991f-f8df4b8e1f27︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1013, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/frame.py\", line 369, in __init__\n    arrays, columns = _to_arrays(data, columns, dtype=dtype)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/frame.py\", line 6258, in _to_arrays\n    dtype=dtype)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/frame.py\", line 6350, in _list_of_series_to_arrays\n    indexer = indexer_cache[id(index)] = index.get_indexer(columns)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/indexes/base.py\", line 2662, in get_indexer\n    target = _ensure_index(target)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/indexes/base.py\", line 4209, in _ensure_index\n    return Index(index_like)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/indexes/base.py\", line 355, in __new__\n    cls._scalar_data_error(data)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/pandas/core/indexes/base.py\", line 710, in _scalar_data_error\n    repr(data)))\nTypeError: Index(...) must be called with a collection of some kind, 'tip_perc' was passed\n"}︡{"done":true}︡
︠0a90b463-9363-498f-afbe-d55c87b595dc︠
colmns.extend((''))
︡7b73b049-ca54-436d-b615-9616f85761f0︡
︠9eb255dc-90d7-4358-a2e2-9b7e1a11c47eso︠
X = pd.DataFrame(df_tips, columns = ['total bill', 'sex' , 'smoker' , 'day' , 'time' , 'size'])
y = pd.DataFrame(df_tips, columns = ['tip'])
print(df_tips.head)
︡6e41569f-6a39-4357-8af2-9e1f4980e2f5︡{"stdout":"<bound method DataFrame.head of      total_bill   tip     sex smoker   day    time  size\n0         16.99  1.01  Female     No   Sun  Dinner     2\n1         10.34  1.66    Male     No   Sun  Dinner     3\n2         21.01  3.50    Male     No   Sun  Dinner     3\n3         23.68  3.31    Male     No   Sun  Dinner     2\n4         24.59  3.61  Female     No   Sun  Dinner     4\n5         25.29  4.71    Male     No   Sun  Dinner     4\n6          8.77  2.00    Male     No   Sun  Dinner     2\n7         26.88  3.12    Male     No   Sun  Dinner     4\n8         15.04  1.96    Male     No   Sun  Dinner     2\n9         14.78  3.23    Male     No   Sun  Dinner     2\n10        10.27  1.71    Male     No   Sun  Dinner     2\n11        35.26  5.00  Female     No   Sun  Dinner     4\n12        15.42  1.57    Male     No   Sun  Dinner     2\n13        18.43  3.00    Male     No   Sun  Dinner     4\n14        14.83  3.02  Female     No   Sun  Dinner     2\n15        21.58  3.92    Male     No   Sun  Dinner     2\n16        10.33  1.67  Female     No   Sun  Dinner     3\n17        16.29  3.71    Male     No   Sun  Dinner     3\n18        16.97  3.50  Female     No   Sun  Dinner     3\n19        20.65  3.35    Male     No   Sat  Dinner     3\n20        17.92  4.08    Male     No   Sat  Dinner     2\n21        20.29  2.75  Female     No   Sat  Dinner     2\n22        15.77  2.23  Female     No   Sat  Dinner     2\n23        39.42  7.58    Male     No   Sat  Dinner     4\n24        19.82  3.18    Male     No   Sat  Dinner     2\n25        17.81  2.34    Male     No   Sat  Dinner     4\n26        13.37  2.00    Male     No   Sat  Dinner     2\n27        12.69  2.00    Male     No   Sat  Dinner     2\n28        21.70  4.30    Male     No   Sat  Dinner     2\n29        19.65  3.00  Female     No   Sat  Dinner     2\n..          ...   ...     ...    ...   ...     ...   ...\n214       28.17  6.50  Female    Yes   Sat  Dinner     3\n215       12.90  1.10  Female    Yes   Sat  Dinner     2\n216       28.15  3.00    Male    Yes   Sat  Dinner     5\n217       11.59  1.50    Male    Yes   Sat  Dinner     2\n218        7.74  1.44    Male    Yes   Sat  Dinner     2\n219       30.14  3.09  Female    Yes   Sat  Dinner     4\n220       12.16  2.20    Male    Yes   Fri   Lunch     2\n221       13.42  3.48  Female    Yes   Fri   Lunch     2\n222        8.58  1.92    Male    Yes   Fri   Lunch     1\n223       15.98  3.00  Female     No   Fri   Lunch     3\n224       13.42  1.58    Male    Yes   Fri   Lunch     2\n225       16.27  2.50  Female    Yes   Fri   Lunch     2\n226       10.09  2.00  Female    Yes   Fri   Lunch     2\n227       20.45  3.00    Male     No   Sat  Dinner     4\n228       13.28  2.72    Male     No   Sat  Dinner     2\n229       22.12  2.88  Female    Yes   Sat  Dinner     2\n230       24.01  2.00    Male    Yes   Sat  Dinner     4\n231       15.69  3.00    Male    Yes   Sat  Dinner     3\n232       11.61  3.39    Male     No   Sat  Dinner     2\n233       10.77  1.47    Male     No   Sat  Dinner     2\n234       15.53  3.00    Male    Yes   Sat  Dinner     2\n235       10.07  1.25    Male     No   Sat  Dinner     2\n236       12.60  1.00    Male    Yes   Sat  Dinner     2\n237       32.83  1.17    Male    Yes   Sat  Dinner     2\n238       35.83  4.67  Female     No   Sat  Dinner     3\n239       29.03  5.92    Male     No   Sat  Dinner     3\n240       27.18  2.00  Female    Yes   Sat  Dinner     2\n241       22.67  2.00    Male    Yes   Sat  Dinner     2\n242       17.82  1.75    Male     No   Sat  Dinner     2\n243       18.78  3.00  Female     No  Thur  Dinner     2\n\n[244 rows x 7 columns]>\n"}︡{"done":true}︡
︠22dc1647-5515-44c0-97ff-891194040303s︠
# use dummy variables for smoker
new_df_tips = pd.get_dummies(df_tips, columns = ['smoker'])
#print(list(new_df_tips.columns.values))
feature_cols = ['smoker_Yes','smoker_No']
X = pd.DataFrame(new_df_tips, columns = feature_cols)
print(X)
y = pd.DataFrame(df_tips, columns = ['tip'])
#print(y)
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size = 0.25, random_state = 0)
regModel = LinearRegression()
regModel.fit(X_train, y_train)
#print(" ")

︡f8604fb0-5b98-4733-8790-88cecfb46079︡{"stdout":"     smoker_Yes  smoker_No\n0             0          1\n1             0          1\n2             0          1\n3             0          1\n4             0          1\n5             0          1\n6             0          1\n7             0          1\n8             0          1\n9             0          1\n10            0          1\n11            0          1\n12            0          1\n13            0          1\n14            0          1\n15            0          1\n16            0          1\n17            0          1\n18            0          1\n19            0          1\n20            0          1\n21            0          1\n22            0          1\n23            0          1\n24            0          1\n25            0          1\n26            0          1\n27            0          1\n28            0          1\n29            0          1\n..          ...        ...\n214           1          0\n215           1          0\n216           1          0\n217           1          0\n218           1          0\n219           1          0\n220           1          0\n221           1          0\n222           1          0\n223           0          1\n224           1          0\n225           1          0\n226           1          0\n227           0          1\n228           0          1\n229           1          0\n230           1          0\n231           1          0\n232           0          1\n233           0          1\n234           1          0\n235           0          1\n236           1          0\n237           1          0\n238           0          1\n239           0          1\n240           1          0\n241           1          0\n242           0          1\n243           0          1\n\n[244 rows x 2 columns]\n"}︡{"stdout":"LinearRegression(copy_X=True, fit_intercept=True, n_jobs=1, normalize=False)\n"}︡{"done":true}︡
︠b6bc4175-5768-4957-88c3-167d7288b5c7s︠
beta_0 = regModel.intercept_
print(beta_0)
︡e8a87965-a6a2-41ab-9b66-f1cf01fd9185︡{"stdout":"[ 2.97099262]\n"}︡{"done":true}︡
︠a7a9bc97-2536-4ece-80b6-7a486bf0afc3s︠
averagey = y.mean()
print(averagey)
︡14ad6400-2d04-470b-9d7e-df17d682e19c︡{"stdout":"tip    2.998279\ndtype: float64\n"}︡{"done":true}︡
︠634f9958-9520-408c-98ea-bd7a42e854dfss︠
beta_1_1 = regModel.coef_[0,0]
print(beta_1_1)
︡dbfec0b2-48e6-4963-a07e-1d3429e3449c︡{"stdout":"0.0555225330225\n"}︡{"done":true}︡
︠00a3bd3a-b4ef-460c-b62d-b7ad5cdb0a3cs︠
beta_1_2 = regModel.coef_[0,1]
print(beta_1_2)
︡77155cfd-1be5-40e9-92b2-e074692d03e5︡{"stdout":"-0.0555225330225\n"}︡{"done":true}︡
︠e56c6b55-91bd-44aa-9a34-1ec913f6bfaes︠
y_pred = regModel.predict(X_test)
regModel_score = r2_score(y_test, y_pred)
print("R^2 score for the model is ", regModel_score)
︡3204f0e1-e1a6-4c4f-a006-980013f4a694︡{"stdout":"('R^2 score for the model is ', -0.023538757252183018)\n"}︡{"done":true}︡
︠4e23cf13-8ca1-4092-8fab-ce070c04f48a︠
print(X.shape)

︡25dfc328-2911-4a87-9564-100bec3e2b92︡{"stdout":"(244, 2)\n"}︡{"stdout":"     smoker_Yes  smoker_No\n0             0          1\n1             0          1\n2             0          1\n3             0          1\n4             0          1\n5             0          1\n6             0          1\n7             0          1\n8             0          1\n9             0          1\n10            0          1\n11            0          1\n12            0          1\n13            0          1\n14            0          1\n15            0          1\n16            0          1\n17            0          1\n18            0          1\n19            0          1\n20            0          1\n21            0          1\n22            0          1\n23            0          1\n24            0          1\n25            0          1\n26            0          1\n27            0          1\n28            0          1\n29            0          1\n..          ...        ...\n214           1          0\n215           1          0\n216           1          0\n217           1          0\n218           1          0\n219           1          0\n220           1          0\n221           1          0\n222           1          0\n223           0          1\n224           1          0\n225           1          0\n226           1          0\n227           0          1\n228           0          1\n229           1          0\n230           1          0\n231           1          0\n232           0          1\n233           0          1\n234           1          0\n235           0          1\n236           1          0\n237           1          0\n238           0          1\n239           0          1\n240           1          0\n241           1          0\n242           0          1\n243           0          1\n\n[244 rows x 2 columns]\n"}︡{"done":true}︡
︠36dea7c5-6c83-4f1c-b733-5e19d52bdades︠
print(y.shape)
︡9e8370cc-14c6-42ec-899f-2cef36f91208︡{"stdout":"(244, 1)\n"}︡{"done":true}︡
︠cf5e2c01-27ee-42f8-918d-83a05cb6127ds︠
ya = np.array(y).reshape(-1,)
print(ya)
︡10010294-e9d6-43df-9f38-90521a57e40b︡{"stdout":"[  1.01   1.66   3.5    3.31   3.61   4.71   2.     3.12   1.96   3.23\n   1.71   5.     1.57   3.     3.02   3.92   1.67   3.71   3.5    3.35\n   4.08   2.75   2.23   7.58   3.18   2.34   2.     2.     4.3    3.     1.45\n   2.5    3.     2.45   3.27   3.6    2.     3.07   2.31   5.     2.24\n   2.54   3.06   1.32   5.6    3.     5.     6.     2.05   3.     2.5    2.6\n   5.2    1.56   4.34   3.51   3.     1.5    1.76   6.73   3.21   2.     1.98\n   3.76   2.64   3.15   2.47   1.     2.01   2.09   1.97   3.     3.14   5.\n   2.2    1.25   3.08   4.     3.     2.71   3.     3.4    1.83   5.     2.03\n   5.17   2.     4.     5.85   3.     3.     3.5    1.     4.3    3.25\n   4.73   4.     1.5    3.     1.5    2.5    3.     2.5    3.48   4.08\n   1.64   4.06   4.29   3.76   4.     3.     1.     4.     2.55   4.     3.5\n   5.07   1.5    1.8    2.92   2.31   1.68   2.5    2.     2.52   4.2\n   1.48   2.     2.     2.18   1.5    2.83   1.5    2.     3.25   1.25   2.\n   2.     2.     2.75   3.5    6.7    5.     5.     2.3    1.5    1.36\n   1.63   1.73   2.     2.5    2.     2.74   2.     2.     5.14   5.     3.75\n   2.61   2.     3.5    2.5    2.     2.     3.     3.48   2.24   4.5\n   1.61   2.    10.     3.16   5.15   3.18   4.     3.11   2.     2.     4.\n   3.55   3.68   5.65   3.5    6.5    3.     5.     3.5    2.     3.5    4.\n   1.5    4.19   2.56   2.02   4.     1.44   2.     5.     2.     2.     4.\n   2.01   2.     2.5    4.     3.23   3.41   3.     2.03   2.23   2.     5.16\n   9.     2.5    6.5    1.1    3.     1.5    1.44   3.09   2.2    3.48\n   1.92   3.     1.58   2.5    2.     3.     2.72   2.88   2.     3.     3.39\n   1.47   3.     1.25   1.     1.17   4.67   5.92   2.     2.     1.75   3.  ]\n"}︡{"done":true}︡
︠08cabe87-a06a-42f2-9ca4-426f21098e1ds︠
xyes = np.array(X['smoker_Yes'])
print(xyes)
︡f35155d3-36df-4e96-aed7-7fb2d2e37fd0︡{"stdout":"[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 1 1 1 1 0 0 0 1 0 1 0 0 1 1\n 0 0 1 0 0 0 1 0 0 1 0 0 0 0 0 0 1 0 1 1 0 1 1 1 1 0 1 1 1 1 0 1 1 1 0 1 0\n 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0\n 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1\n 0 1 1 1 1 1 1 1 1 1 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 1 1 1 1 1 1\n 1 0 1 1 1 0 0 1 1 1 0 0 1 0 1 1 0 0 1 1 0 0]\n"}︡{"done":true}︡
︠07d8c586-243a-4b1f-b74e-76e83bada52ds︠
xno = np.array(X['smoker_No'])
print(xno)
︡1edf6ae3-316c-49d7-9dcd-cde0eae4a9dd︡{"stdout":"[1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1\n 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 1 0 1 0 0 0 0 1 1 1 0 1 0 1 1 0 0\n 1 1 0 1 1 1 0 1 1 0 1 1 1 1 1 1 0 1 0 0 1 0 0 0 0 1 0 0 0 0 1 0 0 0 1 0 1\n 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 1 1 1 1 1 1\n 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0\n 0 1 0 0 0 1 1 0 0 0 1 1 0 1 0 0 1 1 0 0 1 1]\n"}︡{"done":true}︡
︠e46cee8b-785d-44b4-b1bb-1ab914020f9cs︠
fig = plt.figure(figsize=(12,8))
ax = fig.gca(projection='3d')
ax.scatter3D(xyes, xno, ya, c=ya, cmap='Reds', s=80)
ax.set_xlabel('smokers', fontsize=20)
ax.set_ylabel('non smokers', fontsize=20)
ax.set_zlabel('tip', fontsize=20)
plt.title('Actual Observations', fontsize=20)
plt.show()
#ax.legend()

︡72f2c3da-cb01-4a0a-8d39-660b82cdfc2f︡{"stdout":"<mpl_toolkits.mplot3d.art3d.Path3DCollection object at 0x7f3dc279f650>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f3dc28bebd0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f3dc27ee7d0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f3dc2805250>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f3dc2787550>\n"}︡{"file":{"filename":"0b98a6d5-cef2-4ee2-8fbc-07e69e6d44f1.svg","show":true,"text":null,"uuid":"beb7b0f5-d7da-48d9-9d65-67651af47dfb"},"once":false}︡{"done":true}︡
︠553b415d-4058-4557-b690-1ab60afe371ds︠
def f(x1, x2, b0, b1, b2):
    return b0 + b1 * x1 + b2 * x2
︡2a0e5f0f-65e9-4fb8-9bf5-88c95f54d4a7︡{"done":true}︡
︠1c352b79-253f-483a-ae9a-265a22382665s︠
esttips = f(xyes, xno, beta_0, beta_1_1, beta_1_2)

︡cf8a88d4-f8fd-4cc3-9a81-bcbfc60180cf︡{"done":true}︡
︠599afda5-e002-4bcc-b3a0-27247687a417s︠
fig = plt.figure(figsize=(12,8))
plt.plot(ya)
plt.plot(esttips)
plt.show()
︡3b8474ea-7f2d-4dbd-9cda-25eefc28e731︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f3dc2755e50>]"}︡{"stdout":"\n"}︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f3dc2755f90>]\n"}︡{"file":{"filename":"36193142-87e8-4fc3-8107-f2739ea21785.svg","show":true,"text":null,"uuid":"a0d40708-04df-4563-bcdc-bfa5d83b9b12"},"once":false}︡{"done":true}︡
︠e1778c3d-9f1a-4118-aa59-0b7944b0063b︠
fig = plt.figure(figsize=(12,8))
ax = fig.gca(projection='3d')
ax.plot_wireframe(xx1, xx2, Z, rstride=5, cstride=6,  alpha=0.2) #cmap='cubehelix', #
ax.scatter3D(xbill, xsize, ya, color = 'green', s=80) #c=ya,
ax.set_xlabel('bill', fontsize=20)
ax.set_ylabel('size of party', fontsize=20)
ax.set_zlabel('tip', fontsize=20)
ax.set_zlim(0, ya.max())
plt.title('Linear Model to Estimate/Predict Tip', fontsize=20)
ax.legend()
plt.show()
︡d7ee1fd0-842a-456e-8cad-775134a3709b︡
︠69665aa9-0c99-4d07-98f9-932537599d05o︠
︠4219cc74-6832-4a31-a931-a815c642a462︠









